//mp4ogg.js
//
// requirements
//    MP4Box.exe
//    ffmpeg.exe
//    oggenc.exe
//
// this script is the MIT License.
//  http://www.opensource.org/licenses/mit-license.php

var WshShell = new ActiveXObject("WScript.Shell");
var fso = new ActiveXObject("Scripting.FileSystemObject");
var m4aRe = /\.m4a$/i
var oggRe = /\.ogg$/i
var mydir = fso.GetFolder(".");// music
var binpath = "..\\bin\\"
var fileList = new Enumerator(mydir.files);
while (!fileList.atEnd()){
    var myfile = fileList.item();
    //myfile.search() not work.
    if(m4aRe.test(myfile)){
        var inFileName = myfile.Name;
        var outFileName = inFileName.replace(m4aRe, ".ogg");
        if (!fso.FileExists(".\\" + outFileName)){
            WScript.Echo(myfile + " getting info start.");
            var myMP4Box = WshShell.Exec(binpath + "MP4Box -info " + '"' +
                                         myfile + '"');
            while (myMP4Box.Status == 0){
                WScript.Sleep(100);
            }
            var myMP4Info= myMP4Box.StdOut;
            var myInfoRe = [/^\tName:\s+(.*)/, /^\tArtist:\s+(.*)/]
            var myOGGInfo = [];
            while (!myMP4Info.AtEndOfStream){
                var myMP4InfoLine = myMP4Info.ReadLine();
                for (var i = 0; i < myInfoRe.length; i++){
                    if (myInfoRe[i].test(myMP4InfoLine)){
                        myOGGInfo[i] = myInfoRe[i].exec(myMP4InfoLine)[1];
                    }
                }
            }
            if(myOGGInfo[0]==null){
                myOGGInfo[0] = "No Title";
            }
            if(myOGGInfo[1]==null){
                 myOGGInfo[1] = "Unknown Artist"
            }
            WScript.Echo(myfile + " getting info end.");
            WScript.Echo(myfile + " decoding start.");
            var myffm = WshShell.Exec(binpath + "ffmpeg -y -i " + '"' +
                                      myfile + '"' + " tmp.wav");
            while (myffm.Status == 0){
                WScript.Sleep(100);
            }
            WScript.Echo(myfile + " decoding end.");
            WScript.Echo(myfile + " encoding start.");
            // if use Exec, failed getting ExitCode...
            WshShell.Run(binpath + "oggenc.exe -o " + '"' + outFileName + '"'
                         + " --title=" + '"' + myOGGInfo[0] + '"' +
                         " --artist=" + '"' + myOGGInfo[1] + '"' +
                         " tmp.wav", 1, true);
            WScript.Echo(myfile + " encoding end.");
        }
     }
        fileList.moveNext();
}
fso.DeleteFile (".\\tmp.wav");
